scm ABP_GS :

/* alterning bit protocol, from e.g. Grégoire Sutre's PhD thesis */

nb_channels = 2 ;
/* 
channel 0: from sender to receiver
channel 1: from receiver to sender
*/

parameters : 
real m0 ; /* msg with bit 0 */
real m1 ; /* msg with bit 1 */
real a0 ; /* ack with bit 0 */
real a1 ; /* ack with bit 1 */

automaton sender :

initial : 0

state 0 :
to 1 :  when true , 0 ! m0  ;

state 1 :
to 1 :  when true , 0 ! m0 ;
to 1 :  when true , 1 ? a1 ;
to 2 :  when true , 1 ? a0 ;

state 2 :
to 3 :  when true , 0 ! m1  ;

state 3 :
to 3 :  when true , 0 ! m1 ;
to 3 :  when true , 1 ? a0 ;
to 0 :  when true , 1 ? a1 ;


automaton receiver :

initial : 0

state 0 :
to 0 :  when true , 1 ! a1 ;
to 0 :  when true , 0 ? m1 ;
to 1 :  when true , 0 ? m0 ;

state 1 :
to 2 :  when true , 1 ! a0  ;


state 2 :
to 2 :  when true , 1 ! a0 ;
to 2 :  when true , 0 ? m0 ;
to 3 :  when true , 0 ? m1 ;

state 3 :
to 0 :  when true , 1 ! a1  ;


bad_states:
(automaton sender: in 0: true in 2: true in 3: true
automaton receiver: in 1: true)

(automaton sender: in 0: true in 1: true in 2: true
automaton receiver: in 3: true)

(automaton sender: in 0: true
automaton receiver: in 2: true) 

(automaton sender: in 2: true
automaton receiver: in 0: true) 
