(***********************************************************************)
(*                                                                     *)
(*            The Symbolic Communicating Machines Library              *)
(*                                                                     *)
(*                Bertrand Jeannet and Tristan Le Gall                 *)
(*                                                                     *)
(*  Copyright 2008 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU Library General Public License, with    *)
(*  the special exception on linking described in file LICENSE.        *)
(*                                                                     *)
(***********************************************************************)


(* Exemple-bidon pour tester l'analyseur *)

open Apron
open Format
open StandardSem

(* Modules *)


type apron = Polka.loose Polka.t

module Custom =
  struct
(*    type tlattice = Scm_manager.bidon *)
    type tlattice = apron Abstract1.t 

  end

module Analyzer = Scm_analyzer.Make(Custom)


let _ = 
      Format.printf "Lecture du SCM :@." ;

  let scm_lu = Frontend.parse_lexbuf Format.std_formatter (Lexing.from_channel stdin) in

  let scm_glob = Scm_prod.from_syntree scm_lu in 
    Scm_syn.check_global_scm scm_glob ;
(*
   let manager = Scm_manager.finite_manager ~k_forward:2 () scm_glob in
*)
  let man_apron = Polka.manager_alloc_loose () in
  let opt = Apron.Manager.get_funopt man_apron Apron.Manager.Funid_widening in
  let opt2 = { opt with Apron.Manager.algorithm= -1 } in
    Apron.Manager.set_funopt man_apron Apron.Manager.Funid_widening opt2;


  let manager = 
    Scm_manager.apron_manager 
      ~k_forward:2 
      ~threshold:true 
      man_apron 
      scm_glob 
  in 
 
    Analyzer.analyze scm_glob manager


