(***********************************************************************)
(*                                                                     *)
(*            The Symbolic Communicating Machines Library              *)
(*                                                                     *)
(*                Bertrand Jeannet and Tristan Le Gall                 *)
(*                                                                     *)
(*  Copyright 2008 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU Library General Public License, with    *)
(*  the special exception on linking described in file LICENSE.        *)
(*                                                                     *)
(***********************************************************************)

(** SCM analyzer: printing functions module *)

open Scm_syn


val print_scalar: Format.formatter -> scalar -> unit

val print_interval: Format.formatter -> interval -> unit

val print_iexpr : Format.formatter -> iexpr -> unit

val print_bexpr : Format.formatter -> bexpr -> unit

val print_action : Format.formatter -> (int * taction * var) option -> unit

val print_transition : Format.formatter -> transition -> unit

val print_scm  : Format.formatter -> scm -> unit

val print_global_scm  : Format.formatter -> global_scm -> unit
