(***********************************************************************)
(*                                                                     *)
(*            The Symbolic Communicating Machines Library              *)
(*                                                                     *)
(*                Bertrand Jeannet and Tristan Le Gall                 *)
(*                                                                     *)
(*  Copyright 2008 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU Library General Public License, with    *)
(*  the special exception on linking described in file LICENSE.        *)
(*                                                                     *)
(***********************************************************************)

(** SCM analyzer: product of SCMs module *)

val from_syntree : Scm_syn.scm ->  Scm_syn.global_scm

(* converts the syntax tree to a global scm *)


val asynchronous_product :   
  ?disjoint_channels:bool -> 
  Scm_syn.global_scm -> 
  Scm_syn.global_scm -> 
  Scm_syn.global_scm


val synchronous_product :
  ?same_variables:bool ->
  Scm_syn.global_scm ->  
  Scm_syn.global_scm ->   
  Scm_syn.global_scm 
